//+------------------------------------------------------------------+
//|                                              PatternLauncher.mqh |
//|                           Copyright 2019-2020, Dmitri Pecheritsa |
//|                                                 792112@gmail.com |
//+------------------------------------------------------------------+
//| 23 design patterns                                               |
//+------------------------------------------------------------------+
//   purpose > creational > 5
//      abstract factory, builder, factory method, prototype, singleton
//   purpose > structural > 7
//      adapter, bridge, composite, decorator, facade, flyweight, proxy
//   purpose > behavioral > 11
//      chain of responsibility, command, interpreter, iterator, mediator,
//      memento, observer, state, strategy, template method, visitor
//   scope > class > 3 > factory method, interpreter, template method
//   scope > object > 20 > all other
//+------------------------------------------------------------------+
//| structural > bridge                                              |
//+------------------------------------------------------------------+
//   decouple an abstraction from its implementation
//    so that the two can vary independently
//
//|Client|
//   |
//   +-->|   Abstraction  |----------------->| Implementor  |
//       |----------------|                  |--------------|
//       |Operation()     |                  |OperationImp()|
//       | imp.Operation()|                         ^
//               ^                                  |
//               |                       +----------+----------+
//               |                       |                     |
//      |RefinedAbstraction|  |ConcreteImplementorA| |ConcreteImplementorB|
//                            |--------------------| |--------------------|
//                            |OperationImp()      | |OperationImp()      |
//
//+------------------------------------------------------------------+
//| load and run                                                     |
//+------------------------------------------------------------------+
#include "PatternOrganizer.mqh"
void OnStart() //launch pattern clients one by one and check result
  {
   Run(new Structural::Bridge::Client);
  }
//+------------------------------------------------------------------+
//| output                                                           |
//+------------------------------------------------------------------+
//   Structural::Bridge::Client::Output
//   Implementor A
//   Implementor B
//+------------------------------------------------------------------+
